// ANCHOR: here
fn first_word(s: &str) -> &str {
    let bytes = s.as_bytes();

    for (i, &item) in bytes.iter().enumerate() {
        if item == b' ' {
            return &s[0..i];
        }
    }

    &s[..]
}
// ANCHOR_END: here

fn main() {
    let my_string = String::from("witaj świecie");

    // first_word działa na wycinkach typów `String`
    let word = first_word(&my_string[..]);

    let my_string_literal = "witaj świecie";

    // first_word działa ne wycinkach literałów łańcuchów znaków
    let word = first_word(&my_string_literal[..]);

    // Ponieważ literały łańcuchów znaków *są* już wycinkami łańcuchów znaków,
    // to również działa bez konieczności stosowania składni wycinków!
    let word = first_word(my_string_literal);
}
